<?php
if (!defined('SMF'))
	die('Hacking attempt...');

function MetaTagsSpecialChars ($text)
{
	return str_replace('"', '&quot;', strip_tags(html_entity_decode($text, ENT_QUOTES)));
}

function MetaTagsGenerateKeywords ($text)
{
	$common_words = array('a', 'and', '&', 'at', 'as', 'for', 'it', 'in', 'of', 'on', 'or', 'quot', 'the', 'to');

	$text = MetaTagsSpecialChars(str_replace(',', '', $text));

	// Build array of the keywords without punctuation.
	preg_match_all('/\w+/', $text, $keywords);

	// Only one keyword, just return.
	if(count($keywords[0]) == 1)
		return $text;

	// Remove any common words.
	$i=0;
	foreach($keywords[0] as $word)
	{
		if(in_array($word, $common_words))
			unset($keywords[0][$i]);
		$i++;
	}

	// Return the individual keywords along with the keyword string.
	return implode(', ', $keywords[0]) . ', ' . $text;
}

function MetaTagsGenerateTeaser ($id_msg)
{
	global $smcFunc;

	$request = $smcFunc['db_query']('', '
		SELECT body
		FROM {db_prefix}messages
		WHERE id_msg = {int:id_msg}',
		array(
			'id_msg' => $id_msg
		));

	list ($teaser) = $smcFunc['db_fetch_row']($request);
	$smcFunc['db_free_result']($request);

	// Format as a plain text string.
	$teaser = MetaTagsSpecialChars(str_replace('<br />', ' ', parse_bbc($teaser)));

	// Less than the teasear limit, just return.
	if(strlen($teaser) < 150)
		return $teaser;

	// Otherwise grab the teaser.
	$teaser = substr($teaser, 0, 150);
	return substr($teaser, 0, strrpos($teaser, ' '));
}

?>
